import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Scanner;


public class Segments {
	public static void main(String[] args) throws Exception
	{
		new Segments().solve();
	}
	
	public long det(int a1, int b1, int a2, int b2)
	{
		return (1l*a1*b2 - 1l*a2*b1);
	}
	
	public class Segment
	{
		int x1, y1, x2, y2;
		public Segment(int _x1, int _y1, int _x2, int _y2)
		{
			x1 = _x1;
			y1 = _y1;
			x2 = _x2;
			y2 = _y2;
		}
		
		private boolean in(int a, int b, int value)
		{
			return value > a && value < b;
		}
		
		public boolean Intersect(Segment s) throws Exception
		{
			int a1 = x2 - x1;
			int b1 = -(s.x2 - s.x1);
			int c1 = s.x1 - x1;
			
			int a2 = y2 - y1;
			int b2 = -(s.y2 - s.y1);
			int c2 = s.y1 - y1;
			
			long det = det(a1, b1, a2, b2);
			if (det != 0)
				return false;
			
			long det1 = det(c1, b1, c2, b2);
			long det2 = det(a1, c1, a2, c2);
			
			if(det1 != 0 || det2 != 0)
				return false;

			int min1x = Math.min(x1, x2);
			int max1x = Math.max(x1, x2);
			
			int min1y = Math.min(y1, y2);
			int max1y = Math.max(y1, y2);
			
			int min2x = Math.min(s.x1, s.x2);
			int max2x = Math.max(s.x1, s.x2);
			
			int min2y = Math.min(s.y1, s.y2);
			int max2y = Math.max(s.y1, s.y2);
			
			if (min1x == max1x)
			{
				return in(min1y, max1y, s.y1) || in(min1y, max1y, s.y2) || in(min2y, max2y, y1) || in(min2y, max2y, y2);
			}
			else if (min1y == max1y)
			{
				return in(min1x, max1x, s.x1) || in(min1x, max1x, s.x2) || in(min2x, max2x, x1) || in(min2x, max2x, x2);
			}
			else
			{
				return (in(min1y, max1y, s.y1) || in(min1y, max1y, s.y2) || in(min2y, max2y, y1) || in(min2y, max2y, y2)) &&
					   (in(min1x, max1x, s.x1) || in(min1x, max1x, s.x2) || in(min2x, max2x, x1) || in(min2x, max2x, x2));
			}
		}
	}

	Scanner in = null;
	PrintWriter out = null;
	
	private void solve() throws Exception
	{
		in = new Scanner(new FileReader("segment.in"));
		//out = new PrintWriter("segment.out");
		out = new PrintWriter(System.out);
		
		int testn = in.nextInt();
		for (int testi = 0; testi < testn; testi++)
		{
			int n = in.nextInt();
			if (n < 1 || n > 10000)
				throw new Exception("Assert!!!");
		
			Segment[] s = new Segment[n];
			for (int i = 0; i < n; i++)
			{
				int x1 = in.nextInt();
				int y1 = in.nextInt();
				int x2 = in.nextInt();
				int y2 = in.nextInt();
				if (x1 < 0 || x1 > 1000000)
					throw new Exception("Assert!!!");
				if (y1 < 0 || y1 > 1000000)
					throw new Exception("Assert!!!");
				if (x2 < 0 || x2 > 1000000)
					throw new Exception("Assert!!!");
				if (y2 < 0 || y2 > 1000000)
					throw new Exception("Assert!!!");
				if (Math.abs(x1 - x2) == 0 && Math.abs(y1 - y2) == 0)
					throw new Exception("Assert!!!");
				
				s[i] = new Segment(x1, y1, x2, y2);
			}

			int ans = 0;
			for (int i = 0; i < n - 1; i++)
			{
				for (int j = i + 1; j < n; j++)
				{
					if (s[i].Intersect(s[j]))
						ans++;
				}
			}
			out.println(ans);
		}
		in.close();
		out.close();
	}
}
